<div
  class="article article-viewer"
  {{on "props-update" this.updateProps}}
  {{did-insert this.setup}}
  {{did-update this.reset @value}}
  ...attributes
>
  {{#if @preview}}
    {{this.plainBlocks}}
  {{else}}
    {{#each this.blocks as |item|}}
      {{#if (eq item.type "header")}}
        <TextWithOptions
          data-path={{concat @path ".h" item.data.level "Style"}}
          data-name={{@name}}
          data-type="h{{item.data.level}}"
          data-gid={{@gid}}
          data-selectable-level="false"
          @isEditor={{@isEditor}}
          @deviceSize={{@deviceSize}}
          @options={{get this (concat "h" item.data.level "Style")}}
          @tag="h"
          @level={{item.data.level}}
        >{{!
        }}{{item.data.text}}{{!
      }}</TextWithOptions>
      {{else if (eq item.type "paragraph")}}
        <TextWithOptions
          data-path={{concat @path ".paragraphStyle"}}
          data-name={{@name}}
          data-type="paragraph"
          data-gid={{@gid}}
          @isEditor={{@isEditor}}
          @deviceSize={{@deviceSize}}
          @options={{this.paragraphStyle}}
          @tag="p"
        >{{!
        }}{{item.data.text}}{{!
    }}</TextWithOptions>
      {{else if (eq item.type "list")}}
        <Article::ViewerList @value={{item.data}} />
      {{else if (eq item.type "delimiter")}}
        <div class="ce-delimiter cdx-block"></div>
      {{else if (eq item.type "quote")}}
        <blockquote class="blockquote text-{{item.data.alignment}}">
          <p class="mb-0">{{item.data.text}}</p>
          <footer class="blockquote-footer">{{item.data.caption}}</footer>
        </blockquote>
      {{else if (eq item.type "table")}}
        <table class="table">
          <thead>
            <tr>
              {{#each item.data.header as |item|}}
                <th scope="col">{{item}}</th>
              {{/each}}
            </tr>
          </thead>
          <tbody>
            {{#each item.data.body as |row|}}
              <tr>
                {{#each row as |item|}}
                  <td>{{item}}</td>
                {{/each}}
              </tr>
            {{/each}}
          </tbody>
        </table>
      {{else if (eq item.type "embed")}}
        <figure class="figure embed">
          <iframe
            src={{item.data.embed}}
            title={{item.data.caption}}
            allow="autoplay; encrypted-media; picture-in-picture"
            class={{item.data.service}}
            allowfullscreen=""
            frameborder="0"
          ></iframe>
          {{#if item.data.caption}}
            <figcaption class="figure-caption">{{clear-html item.data.caption}}</figcaption>
          {{/if}}
        </figure>
      {{else}}
        {{yield item}}
      {{/if}}
    {{/each}}
  {{/if}}
</div>